package coffee._finally.keycloak_metrics;

import org.keycloak.events.Event;
import org.keycloak.events.EventListenerProvider;
import org.keycloak.events.admin.AdminEvent;

public class MetricsEventListenerProvider implements EventListenerProvider {

    public static final String ID = "metrics-listener";

    @Override
    public void onEvent(Event event) {
        Metrics.getInstance().incrementLabelled(
                "user_event",
                event.getRealmId(), event.getType().toString()
        );
    }

    @Override
    public void onEvent(AdminEvent adminEvent, boolean b) {
        Metrics.getInstance().incrementLabelled(
                "admin_event",
                adminEvent.getRealmId(),
                adminEvent.getOperationType().toString(),
                adminEvent.getResourceTypeAsString()
        );
        switch (adminEvent.getOperationType()) {
            case CREATE:
                Metrics.getInstance().incrementLabelled(
                        adminEvent.getResourceTypeAsString().toLowerCase(),
                        adminEvent.getRealmId()
                );
                break;
            case DELETE:
                Metrics.getInstance().decrementLabelled(
                        adminEvent.getResourceTypeAsString().toLowerCase(),
                        adminEvent.getRealmId()
                );
                break;
            case UPDATE:
            case ACTION:
                break;
        }
    }

    @Override
    public void close() {

    }
}
